import sys, os, arcpy


inp_AsmBlockFC = arcpy.GetParameterAsText(0)
inp_Bundles = arcpy.GetParameterAsText(1)

matrixfields = ['category','bprod', 'bhab', 'bsoil', 'tprod', 'thab','hotcold']
matrixvals = []
with arcpy.da.SearchCursor(inp_Bundles,field_names=matrixfields) as Curs:
	for catrow in Curs:
		matrixvals.append(catrow)



#adding ES fields if missing	
addedfields = []

field_names = [f.name.lower() for f in arcpy.ListFields(inp_AsmBlockFC)]
for Bundlefield in matrixfields:
	if not Bundlefield in field_names:
		arcpy.AddField_management(inp_AsmBlockFC, Bundlefield.lower(), "Short")
		addedfields.append(Bundlefield)



totalcount = arcpy.GetCount_management (inp_AsmBlockFC)
calculated = 0

with arcpy.da.UpdateCursor(inp_AsmBlockFC,field_names=matrixfields) as updcursor:
	for asmblock in updcursor:
		currcat = asmblock[0]
		# each category field
		for index in range (1,len(matrixfields)):
			fieldname = matrixfields[index]
			#get bundle value
			valuecode = next((val[index] for val in matrixvals if val[0] == currcat),None)
			asmblock[index] = valuecode
			# arcpy.AddMessage("Category: {}, Index: {}, field: {}, val: {}".format(currcat,index,fieldname,valuecode))
		# arcpy.AddMessage("Row: {}".format(asmblock))
		updcursor.updateRow(asmblock)
		calculated = calculated + 1
		arcpy.AddMessage("{}/{}. Values: {}".format(calculated, totalcount, asmblock))