import sys, os, arcpy


inp_AsmBlockFC = arcpy.GetParameterAsText(0)
inp_ESMatrix = arcpy.GetParameterAsText(1)

matrixfields = ['asmicode', 'cat', 'val']
matrixvals = []
with arcpy.da.SearchCursor(inp_ESMatrix,matrixfields) as Curs:
	for catrow in Curs:
		matrixvals.append([catrow[0],catrow[1],catrow[2]])



#adding ES fields if missing	
addedfields = []
ESFields = set([x[0].lower() for x in matrixvals])
ESFieldslist = list(ESFields)
field_names = [f.name.lower() for f in arcpy.ListFields(inp_AsmBlockFC)]
for ESfield in ESFieldslist:
	if not ESfield in field_names:
		arcpy.AddField_management(inp_AsmBlockFC, ESfield.lower(), "Double")
		addedfields.append(ESfield)



totalcount = arcpy.GetCount_management (inp_AsmBlockFC)
calculated = 0
allfields = ['category'] + ESFieldslist
arcpy.AddMessage("Fields: {}".format(allfields))
with arcpy.da.UpdateCursor(inp_AsmBlockFC,field_names=allfields) as updcursor:
	for asmblock in updcursor:
		currcat = asmblock[0]
		# each category field
		for index in range (1,len(allfields)):
			fieldname = allfields[index]
			#get matrix value: from ['asmicode', 'cat', 'val']
			valuecode = next((val[2] for val in matrixvals if val[1] == currcat and val[0].lower() == fieldname.lower()),None)
			asmblock[index] = valuecode
			# arcpy.AddMessage("Category: {}, Index: {}, field: {}, val: {}".format(currcat,index,fieldname,valuecode))
		# arcpy.AddMessage("Row: {}".format(asmblock))
		updcursor.updateRow(asmblock)
		calculated = calculated + 1
		arcpy.AddMessage("{}/{}. Values: {}".format(calculated, totalcount, asmblock))