import sys, os, arcpy

# import arcpy
# import os, os.path
# import zipfile
# import errno
# import ntpath
# import shutil
# from shutil import copyfile
# reload(sys)  # Reload does the trick!
# sys.setdefaultencoding('UTF8')


inp_AsmBlockFC = arcpy.GetParameterAsText(0)
inp_CatTable = arcpy.GetParameterAsText(1)
inp_ReliefFC = arcpy.GetParameterAsText(2)
inp_SoilfcatFC = arcpy.GetParameterAsText(3)

#soilcat fields in inp_CatTable
soilcatConfigFields = ["category", "slopecat", "soilfcat", "natcat"]
#uzpildoma kategoriju matrica iš inp_CatTable. Turi turėti laukus nurodytus soilcatConfigFields
soilcatTypes = []
with arcpy.da.SearchCursor(inp_CatTable,soilcatConfigFields) as Curs:
	for catrow in Curs:
		soilcatTypes.append([catrow[0],catrow[1],catrow[2],catrow[3]])


def getSlopeCat2 (analysisGeom, slopeFC, SlopeField = "slopecat"):
	#masyvas tipas ir p
	intersectParts = []
	with arcpy.da.SearchCursor(slopeFC,["SHAPE@",SlopeField]) as checkCurs:
		for checkRow in checkCurs:
			
			if not checkRow[0].disjoint(analysisGeom):
				intersection = checkRow[0].intersect(analysisGeom,4)
				intersectParts.append([intersection.area,checkRow[1]])
	
	#Get max area
	# arcpy.AddMessage("Parts: {}".format(intersectParts))
	slopetypes = [x[1] for x in intersectParts]
	slopeunique = set(slopetypes)
	# arcpy.AddMessage("Unique types: {}".format(slopeunique))

	maxtype = None
	maxval = 0.00
	sumarray = []
	#kiekvieno tipo summarize
	for val in slopeunique:
		lastsum = sum([x[0] for x in intersectParts if x[1] == val])
		sumarray.append([val, lastsum])
		if lastsum > maxval: 
			maxval = lastsum
			maxtype = val

	# arcpy.AddMessage("Sum array: {}, max type: {}".format(sumarray, maxtype))
	return maxtype



def getsoilCat2 (analysisGeom, soilFC, SField = "soilfcat"):
	#masyvas tipas ir p
	intersectParts = []
	with arcpy.da.SearchCursor(soilFC,["SHAPE@",SField]) as checkCurs:
		for checkRow in checkCurs:
			
			if not checkRow[0].disjoint(analysisGeom):
				intersection = checkRow[0].intersect(analysisGeom,4)
				intersectParts.append([intersection.area,checkRow[1]])
	
	#Get max area
	# arcpy.AddMessage("Parts: {}".format(intersectParts))
	stypes = [x[1] for x in intersectParts]
	sunique = set(stypes)
	# arcpy.AddMessage("Unique types: {}".format(slopeunique))

	maxtype = None
	maxval = 0.00
	sumarray = []
	#kiekvieno tipo summarize
	for val in sunique:
		lastsum = sum([x[0] for x in intersectParts if x[1] == val])
		sumarray.append([val, lastsum])
		if lastsum > maxval: 
			maxval = lastsum
			maxtype = val

	# arcpy.AddMessage("Sum array: {}, max type: {}".format(sumarray, maxtype))
	return maxtype




def getLandCat(landtype, reliefcat, soilcat):
	#define grassland type (land category) by 3 parameters
	landcat = None
	wherec = "natcat = '{}' and slopecat = '{}' and soilfcat='{}'".format(landtype, reliefcat, soilcat)
	with arcpy.da.SearchCursor(categoriestable, field_names=['category'], where_clause=wherec) as catSearchCurs:
		for searchrow in catSearchCurs:
			landcat=searchrow[0]
	
	return landcat



def getESvaluesbyCat(grassCat, countrycode = None):
	ESdict = {}
	wherec = ''
	if countrycode: 
		wherec = "cat='{}' and country_c='{}'".format(grassCat,countrycode)
	else: 
		wherec = "cat='{}' and (country_c is NULL or country_c='')".format(grassCat)
	
	with arcpy.da.SearchCursor(defaultasmi, field_names=['asmicode','val'], where_clause="cat='{}'".format(grassCat)) as catSearchCurs:
		for searchrow in catSearchCurs:
			ESdict[searchrow[0].lower()] = searchrow[1]
	
	#if countrycode expected, but not configured:
	if countrycode and len(ESdict) == 0:
		wherec = "cat='{}' and (country_c is NULL or country_c='')".format(grassCat)
		with arcpy.da.SearchCursor(defaultasmi, field_names=['asmicode','val'], where_clause="cat='{}'".format(grassCat)) as catSearchCurs:
			for searchrow in catSearchCurs:
				ESdict[searchrow[0].lower()] = searchrow[1]
				
	return ESdict

def parseFeats(fset):
	msg = ""
	#paimti feature sluoksnį, padaryti temp kopiją

	outputfc = arcpy.CreateScratchName("vgblock",data_type="FeatureClass ",workspace=arcpy.env.scratchGDB)
	#arcpy.AddMessage("Converting to layer {}".format(outputfc))
	arcpy.CopyFeatures_management(fset, outputfc)
	
	#patikrinti ar yra ES service atributai, jei nėra - pridėti
	#checking sys fields, if missed adding
	for chkfield in ["category","slopecat","soilfcat","natcat"]:
		chkfieldtype = getblockFieldType(chkfield)
		if chkfieldtype is None:
			arcpy.AddField_management(outputfc, chkfield, "TEXT", field_length=20)
			addedfields.append(chkfield)
	
	#adding ES fields if missing	
	ESFields = getESFields()
	for ESfield in ESFields:
		chkfieldtype = getblockFieldType(ESfield)
		if chkfieldtype is None:
			arcpy.AddField_management(outputfc, ESfield, "TEXT", field_length=20)
			addedfields.append(ESfield)
	
	if len(addedfields) > 0:
		arcpy.AddMessage("Added fields: {}".format(addedfields))
		msg = "Added fields: {}".format(addedfields)
	
	#tikrinti kiekvieno objekto tipą: pagal geometriją, pagal nustatytą vietą
	fieldsupd = ["OBJECTID","category","slopecat","soilfcat","natcat"] + ESFields
	#arcpy.AddMessage(fieldsupd)
	with arcpy.da.UpdateCursor(outputfc, fieldsupd) as updcursor:
		for row in updcursor:
			catval = row[fieldsupd.index("category")]
			slopecatval = row[fieldsupd.index("slopecat")]
			soilfcatval = row[fieldsupd.index("soilfcat")]
			natcatval = row[fieldsupd.index("natcat")]
	
			arcpy.AddMessage("Initial Category: {}, slope:{},soil:{},naturality:{}".format(catval,slopecatval,soilfcatval,natcatval))
			
			#if no category defined trying to de
			if catval is None or len(catval.strip())==0:
				#if no cat check each type

				if slopecatval is None:
					#TODO try to define by geometry
					slopecatval = getSlopeCat(outputfc,row[fieldsupd.index("OBJECTID")])
					if slopecatval:
						arcpy.AddMessage("Defined slope: {}".format(slopecatval))
						msg = msg + "\n Slope by geometry: {}".format(slopecatval)
						row[fieldsupd.index("slopecat")] = slopecatval

				if soilfcatval is None:
					#TODO try to define by geometry
					soilfcatval = getSoilCat(outputfc,row[fieldsupd.index("OBJECTID")])
					if soilfcatval:
						arcpy.AddMessage("Defined soil: {}".format(soilfcatval))
						msg = msg + "\n Soil by geometry: {}".format(soilfcatval)
						row[fieldsupd.index("soilfcat")]=soilfcatval
					

				if natcatval is None:
					#TODO try to define by geometry
					natcatval = getNaturalityCat(outputfc,row[fieldsupd.index("OBJECTID")])
					if natcatval:
						arcpy.AddMessage("Defined naturality: {}".format(natcatval))
						msg = msg + "\n Naturality by geometry: {}".format(natcatval)
						row[fieldsupd.index("natcat")] = natcatval
					


				#after defining 3 components, try to define category
				if slopecatval and soilfcatval and natcatval:
					catval = getLandCat(natcatval,slopecatval,soilfcatval)
					arcpy.AddMessage("Category defined by 3 components: {}".format(catval))
					msg = msg + "\n Category defined by 3 components: {}".format(catval)

			#finally define category if possible
			#if catefory defined - define ES values
			#arcpy.AddMessage("Defined Category: {}".format(catval))
			if catval:
				row[fieldsupd.index("category")] = catval
				landtype, reliefcat, soilcat = getCompositeAttribs(catval)
				arcpy.AddMessage("Defined composite: natcat{},slopecat:{},soilfcat:{}".format(landtype,reliefcat,soilcat))
				#'natcat','slopecat','soilfcat'
				row[fieldsupd.index("natcat")] = landtype
				row[fieldsupd.index("slopecat")] = reliefcat
				row[fieldsupd.index("soilfcat")] = soilcat


				for esfield in ESFields:
					catdict = getESvaluesbyCat(catval)
					#arcpy.AddMessage("catdict :{}".format(catdict))
					
					try:
						arcpy.AddMessage("defining field: {}".format(esfield))
						row[fieldsupd.index(esfield)] = catdict[esfield]
					except:
						row[fieldsupd.index(esfield)] = None
						arcpy.AddMessage("Field: {}; Exception: {}".format(esfield, sys.exc_info()[0]))
			else:
				msg = "{} \n Unable to define category type. ES values not calculated".format(msg)
			updcursor.updateRow(row)
			
	#nustatyti grassland tipą
	
	# pagal nustatytą tipą atnaujinti ES atributus
	
	feature_set = arcpy.FeatureSet()
	feature_set.load(outputfc)
	return feature_set, msg

	
def getblockFieldType(fieldname):
	ftype = None
	
	#jeigu nėra reikšmės, užpildomas dictionary. Kiekvieną kartą listfields užtrunka
	if len(grassbfields)<1:
		
	
		fieldlist = arcpy.ListFields(inputrecords)
		
		for field in fieldlist:
			ftype = field.type
			grassbfields[field.name.lower()] = field.type
		#arcpy.AddMessage("Field types: {}".format(stebinfotypes))
	try:
		ftype = grassbfields[fieldname.lower()]
	except:
		ftype = None
			
	return ftype




# with arcpy.da.SearchCursor(inp_AsmBlockFC, field_names=['SHAPE@']) as SearchCurs: 
# 	for asmblock in SearchCurs:
# 		arcpy.AddMessage ("Feature")
# 		slopecat = getSlopeCat2 (asmblock[0], inp_ReliefFC, SlopeField = "slopecat")
# 		soilcat = getsoilCat2 (asmblock[0], inp_SoilfcatFC, SField = "soilfcat")
# 		arcpy.AddMessage ("Slope: {}, soil: {}".format(slopecat,soilcat))

totalcount = arcpy.GetCount_management (inp_AsmBlockFC)
calculated = 0
with arcpy.da.UpdateCursor(inp_AsmBlockFC,field_names=['SHAPE@','category','slopecat','soilfcat','natcat'] ) as updcursor:
	for asmblock in updcursor:
		catval = asmblock[1]
		slopecatval = asmblock[2]
		soilfcatval = asmblock[3]
		natcatval = asmblock[4]

		# arcpy.AddMessage("Initial Category: {}, slope:{},soil:{},naturality:{}".format(catval,slopecatval,soilfcatval,natcatval))
		
		#if no category defined trying to de
		if catval is None or len(catval.strip())==0:
			#if no cat check each type

			if slopecatval is None or len(slopecatval.strip())==0:
				slopecatval =  getSlopeCat2 (asmblock[0], inp_ReliefFC, SlopeField = "slopecat")
				if slopecatval:
					asmblock[2] = slopecatval

			if soilfcatval is None or len(soilfcatval.strip())==0:
				soilfcatval = getsoilCat2 (asmblock[0], inp_SoilfcatFC, SField = "soilfcat")
				if soilfcatval:
					asmblock[3]=soilfcatval


			#after defining 3 components, try to define category
			if slopecatval and soilfcatval and natcatval:
				
				# ["category", "slopecat", "soilfcat", "natcat"]
				catvallist = [x[0] for x in soilcatTypes if (x[1] == slopecatval and x[2] == soilfcatval and x[3] == natcatval)]
				if len(catvallist)>0 :
					catval = catvallist[0]
				else:
					catval = None
				asmblock[1]=catval
		updcursor.updateRow(asmblock)
		calculated = calculated + 1
		arcpy.AddMessage("{}/{}. Category: {}, slope:{},soil:{},naturality:{}".format(calculated, totalcount, catval,slopecatval,soilfcatval,natcatval))
			